unit
  RTC;

interface

uses
  Objects;

type
  PRTDirEntry = ^TRTDirEntry;
  TRTDirEntry = object
    Attr: Word;
    NA: Word;
    ME: Word;
    Ext: Word;
    Size: Word;
    Reserved: Word;
    Date: Word;
  end;

  PRTDirEntry2 = ^TRTDirEntry2;
  TRTDirEntry2 = object (TRTDirEntry)
    Block: Word;
  end;

  TSegment = record
    Segments: Word;
    Next: Word;
    Dummy2: Longint;
    StartData: Word;
    Dir: array [0..72-1] of TRTDirEntry;
    Dummy3: array [1..6] of Byte;
  end;

  PRTCollection = ^TRTCollection;
  TRTCollection = object (TSortedCollection)
    function KeyOf (Item: Pointer): Pointer; virtual;
    function Compare (Key1, Key2: Pointer): Integer; virtual;
    procedure FreeItem (Item: Pointer); virtual;
  end;

implementation

{ TRTCollection }

function TRTCollection.KeyOf;
begin
  KeyOf := Pointer (PRTDirEntry2 (Item)^.Block);
end;

function TRTCollection.Compare;
begin
  if Word (Key1) < Word (Key2)
  then
    Compare := -1
  else
    if Word (Key1) = Word (Key2)
    then Compare := 0
    else Compare := +1;
end;

procedure TRTCollection.FreeItem;
begin
  FreeMem (Item, SizeOf (TRTDirEntry2));
end;

end.
